#!/bin/ksh
#############################################################################################
# @(#) --------------------------------------------------------------------------------------
# @(#) Fichier : DB_SSC.sh
# @(#) Date    : 
# @(#) Auteur  : DBA team IXIS-CiB
# @(#) Id      : $Id: DB_SSC.sh 105 2009-12-18 14:21:03Z lriou $
# @(#)
# @(#) Objet   : Diffuse le contenu du repository SVN sur les serveurs distants
# @(#)
# @(#)
# @(#) --------------------------------------------------------------------------------------
# @(#) USAGE:
# @(#)          DB_SSC.sh [-i file | -s serveur1,serveur2] -o [start|stop|check|checkonly] [-pn°]
# @(#)
# @(#) --------------------------------------------------------------------------------------
# @(#)
# @(#) Exemples:
# @(#)
# @(#)          DB_SSC.sh -s SD_TP_DBA -o start -p 10
# @(#)          DB_SSC.sh -i /tmp/listeserveur -o check
# @(#)
# @(#) --------------------------------------------------------------------------------------
# @(#) Modif   :
# @(#) --------------------------------------------------------------------------------------
#############################################################################################

function sshrunning {
        typeset -u SERVEUR=$1
        machine=$(sed -n -e "/<connection name=\"$SERVEUR\"/,/>/p" ~/.jsqsh/connections.xml  | sed -n -e '/server="/s/.*server="\(.*\)"/\1/p' | sed -e 's/\..*//')
        Alias=$(sed -n -e "/<connection name=\"$SERVEUR\"/,/>/p" ~/.jsqsh/connections.xml  | sed -n -e '/sid="/s/.*sid="\(.*\)"/\1/p' | sed -e 's/\..*//')
        techno=$(sed -n -e "/<connection name=\"$SERVEUR\"/,/>/p" ~/.jsqsh/connections.xml  | sed -n -e '/driver="/s/.*driver="\(.*\)"/\1/p' | sed -e 's/\..*//')
        nomlogin=$(sed -n -e "/<connection name=\"$SERVEUR\"/,/>/p" ~/.jsqsh/connections.xml  | sed -n -e '/domain="/s/.*domain="\(.*\)"/\1/p' | sed -e 's/\..*//')
        #machine=`echo -e "open\nread $1\nclose\nquit" | dscp | grep "Transport Address" | head -1| cut -f2 -d: | sed -e 's/ [0-9]*$//' `
        #[ "$techno" != 'oracle' ] && techno=sybase
        machine=${machine:=$1}
	case $techno in 
		sybaseiq|sybaserep) nomlogin=${nomlogin:='sybase'} ;;
	esac
	nomlogin=${nomlogin:=$techno}
	case $techno in 
		mysql) EXEC2=mys;;
		sybaseiq) EXEC2=iq ;;
		sybase) EXEC2=ase ;;
		sybaserep) EXEC2=rep ;;
		oracle) ;;
	esac
        shift

	[[ "${PARALLELISME}" -eq 1 ]] && echo "ssh $machine $* #${Alias:=$SERVEUR} - $nomlogin - $techno"

	case $techno in 
		sybaseiq|sybase|sybaserep|mysql) 
			ssh -q $machine -l $nomlogin "PATH=/usr/bin:/bin ; export PATH ; /$machine/sgbd/com/startup/${EXEC}_${EXEC2}.ksh $CHECK $SERVEUR" 
		;;
		oracle)
			case $CHECK in
				-c)
					ssh -q $machine -l $nomlogin "[[ -x /usr/ucb/ps ]] && PSCMD='/usr/ucb/ps ax -ww' || PSCMD='ps -ae -o args' ; [[ \$(eval \${PSCMD} | egrep -c '[t]nslsnr ${SERVEUR} ') -eq 1 ]] && echo '$SERVEUR:UP' || echo '$SERVEUR:DOWN' ;[[ \$(eval \${PSCMD} | egrep -c '[o]ra_pmon_${SERVEUR}( |$)') -eq 1 ]] && echo '$SERVEUR(listener):UP' || echo '$SERVEUR(listener):DOWN' ;"
				;;

				*)
					ssh -q $machine -l $nomlogin "PATH=/usr/bin:/bin ; export PATH ; /$machine/sgbd/com/startup/${EXECORA}base_ora.ksh -s $SERVEUR -m $machine" 
				;;
			esac
		;;
	esac
	if [ "$EXEC" != "shutdown" -a -z "$CHECKONLY" ]
	then
		case $techno in 
			sybase|sybaserep) 
				ssh -q $machine -l $nomlogin "cd /$machine/sgbd/$SERVEUR/errorlog/ ; egrep -i '(Msg|error)' /dev/null $SERVEUR.log | tail -5"
			;;
			sybaseiq)
				ssh -q $machine -l $nomlogin "cd \$(egrep '^${SERVEUR}:' /$machine/sgbd/ini/sgbd.ini | cut -f2 -d:)/errorlog ; tail +0\$(grep -n 'OpenDatabase Completed' $SERVEUR.iqmsg | tail -1 | cut -f1 -d:) $SERVEUR.iqmsg | egrep -v '(^I\.|^$|^In table |records were inserted|rows completed for table|in [0-9] seconds)' | tail -5"
			;;
			oracle)
				ssh -q $machine -l $nomlogin "[[ -f /$machine/sgbd/$SERVEUR/$SERVEUR/dump/log/alert_$SERVEUR.log ]] && cd /$machine/sgbd/$SERVEUR/$SERVEUR/dump/log ; [[ -f /$machine/sgbd/$SERVEUR/admin/bdump/alert_$SERVEUR.log ]] && cd /$machine/sgbd/$SERVEUR/admin/bdump/ ; [[ -f /$machine/sgbd/$SERVEUR/diag/rdbms/\$(echo $SERVEUR | tr [A-Z] [a-z])/$SERVEUR/trace/alert_$SERVEUR.log ]] && cd /$machine/sgbd/$SERVEUR/diag/rdbms/\$(echo $SERVEUR | tr [A-Z] [a-z])/$SERVEUR/trace/ ; [[ -f /$machine/sgbd/$SERVEUR/admin/diag/rdbms/\$(echo $SERVEUR | tr [A-Z] [a-z])/$SERVEUR/trace/alert_$SERVEUR.log ]] && cd /$machine/sgbd/$SERVEUR/admin/diag/rdbms/\$(echo $SERVEUR | tr [A-Z] [a-z])/$SERVEUR/trace/ ; egrep -i '(Ora-)' /dev/null alert_$SERVEUR.log | tail -5"
			;;
		esac
	fi
}

usage() {
        cat $0 | grep "# @(#)" | grep -v grep
        exit
}

PARALLELISME=1
while getopts o:i:s:p: _OPT
do
        case ${_OPT} in
                i)	LISTSERVEUR=`cat ${OPTARG}`;;
		o)	case ${OPTARG} in
				check) EXEC="startup"
				       CHECK="-c"
				;;
				start) EXEC="startup"; EXECORA="start";;
				stop) EXEC="shutdown" ; EXECORA="stop";;
				checkonly) EXEC="startup"
				      	   CHECK="-c"
					   CHECKONLY=1
				;;
		  	esac
		 	if [ "X${EXEC}X" == "XX" ]
			then
				usage
			fi
			;;
		s)	LISTSERVEUR=$(echo ${OPTARG} | tr ',' ' ') ;;
		p)	PARALLELISME=${OPTARG};;
		
        esac
done

shift $OPTIND-1

[[ "X${EXEC}X" == "XX" ]] && usage


for serveur in $LISTSERVEUR
do
	sshrunning $serveur &
	if [ $(jobs -l | wc -l ) -ge ${PARALLELISME} ]
	then
		wait
	fi
done
wait

