#!/bin/ksh

#############################################################################################
# @(#) --------------------------------------------------------------------------------------
# @(#) Fichier : RSYNC.sh
# @(#) Date    : 31/03/2006
# @(#) Auteur  : DBA team IXIS-CiB
# @(#) Id      : $Id: dbcc_ase.ksh 105 2009-12-18 14:21:03Z lriou $
# @(#)
# @(#) Objet   : Diffuse le contenu du repository SVN sur les serveurs distants
# @(#)
# @(#)
# @(#) --------------------------------------------------------------------------------------
# @(#) USAGE:
# @(#)          RSYNC.sh repertoire/fichier [repertoire/fichier ...]
# @(#)
# @(#) --------------------------------------------------------------------------------------
# @(#)
# @(#) Exemples:
# @(#)
# @(#)          RSYNC.sh com/util/dbcc_ase.ksh
# @(#)          RSYNC.sh bb
# @(#)
# @(#) --------------------------------------------------------------------------------------
# @(#) Modif   :
# @(#) --------------------------------------------------------------------------------------
#############################################################################################
PROG=${0##*/}
PROG_WEXT=`echo ${PROG} | sed "s/.ksh//g"`
VERSION="$Rev: 105 $"

# ---------------------------------------------------------------------------------
# NOM:                  usage()
# FONCTION:             Donne l'usage du programme
#
# PARAMETRES ATTENDUS:  N/A
# CODES RETOUR:         N/A
# ---------------------------------------------------------------------------------
usage() {
        cat $PROG | grep "# @(#)" | grep -v grep
        exit
}

jsqsh 2> /dev/null <<EOFSQL
\connect -d sybase -S msconteville.cib.net  -p 1050 -U sa -P syb@plage -D dbrepository
select case process_owner when null then 'sybase@' when '' then 'sybase@' else process_owner+'@' end + rtrim(ltrim(host_name))+rtrim(ltrim(domain_name))+':/'+rtrim(ltrim(host_name))+'/sgbd/' from tdbrep,tdbdef,thostrep where tdbdef.dbid=tdbrep.dbid and tdbrep.host_id=thostrep.host_id and thostrep.host_id!=1 and techno in ('ASE','REP','SIQ') and port!=0
union
select case process_owner when null then 'sybase@' when '' then 'sybase@' else process_owner+'@' end + rtrim(ltrim(cluster_name))+rtrim(ltrim(domain_name))+':/'+rtrim(ltrim(cluster_name))+'/sgbd/' from tdbrep,tdbdef,thostrep,tclusterrep where tdbdef.dbid=tdbrep.dbid and thostrep.host_id=tclusterrep.primary_id and tdbrep.cluster_id=tclusterrep.cluster_id and tclusterrep.cluster_id!=1 and techno in ('ASE','REP','SIQ') and port!=0
union
select case process_owner when null then 'oracle@' when '' then '' else process_owner+'@' end + rtrim(ltrim(host_name))+rtrim(ltrim(domain_name))+':/'+rtrim(ltrim(host_name))+'/sgbd/' from tdbrep,tdbdef,thostrep where tdbdef.dbid=tdbrep.dbid and tdbrep.host_id=thostrep.host_id and thostrep.host_id!=1 and techno in ('ORA') and port!=0
union
select case process_owner when null then 'oracle@' when '' then '' else process_owner+'@' end + rtrim(ltrim(cluster_name))+rtrim(ltrim(domain_name))+':/'+rtrim(ltrim(cluster_name))+'/sgbd/' from tdbrep,tdbdef,thostrep,tclusterrep where tdbdef.dbid=tdbrep.dbid and thostrep.host_id=tclusterrep.primary_id and tdbrep.cluster_id=tclusterrep.cluster_id and tclusterrep.cluster_id!=1 and techno in ('ORA') and port!=0
go -H -F -m csv > /tmp/liste.$$
EOFSQL
echo ""
> /tmp/erreurssh.$$
for ligneserveur in `cat /tmp/liste.$$`
do
	echo "## $ligneserveur ##"  >> /tmp/RSYNC.$$ 2>&1
	serveur=$(echo $ligneserveur | cut -f1 -d:)
	ssh -oPreferredAuthentications=publickey -oConnectTimeout=10 $serveur pwd >> /tmp/RSYNC.$$ 2>&1
	if [ $? -ne 0 ]
	then
		echo "!!! Erreur ssh ${ligneserveur} $serveur" >> /tmp/erreurssh.$$
		continue
	fi
done

cat /tmp/erreurssh.$$
\rm /tmp/erreurssh.$$
